package org.onestep.relief.utility.accreditation.model;

import com.amazonaws.services.dynamodbv2.datamodeling.*;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonValue;
import com.fasterxml.jackson.databind.ObjectMapper;
import lombok.AllArgsConstructor;
import lombok.Data;
import org.onestep.relief.utility.accreditation.dao.AccreditationStateConverter;
import org.onestep.relief.utility.accreditation.dao.EntityTypeConverter;
import org.onestep.relief.utility.accreditation.dao.RoleEnumTypeConverter;

import javax.validation.Valid;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

/**
 * Accreditation object.
 */
@Data
@AllArgsConstructor
@DynamoDBTable(tableName = "Accreditations")
@JsonIgnoreProperties(ignoreUnknown = true)
public class Accreditation implements Entity {

    private static final ObjectMapper mapper = new ObjectMapper();

    @JsonProperty("accreditationId")
    @DynamoDBHashKey
    @DynamoDBAutoGeneratedKey
    private String accreditationId = null;

    @JsonProperty
    @DynamoDBRangeKey
    private Date date;

    @JsonProperty("entityId")
    @DynamoDBIndexHashKey(attributeName = "entityId", globalSecondaryIndexName = "entityId-index")
    @DynamoDBAttribute
    private String entityId = null;

    @JsonProperty("role")
    @DynamoDBIndexHashKey(attributeName = "role", globalSecondaryIndexName = "role-index")
    @DynamoDBTypeConverted(converter = RoleEnumTypeConverter.class)
    private RoleEnum role = null;

    @JsonProperty("documents")
    @DynamoDBAttribute
    private List<Document> documents = new ArrayList<>();

    @JsonProperty("accreditationState")
    @DynamoDBTypeConverted(converter = AccreditationStateConverter.class)
    @DynamoDBIndexHashKey(attributeName = "accreditationState", globalSecondaryIndexName = "accreditationState-entityType-index")
    private AccreditationStateEnum accreditationState = null;

    @JsonProperty("entityType")
    @DynamoDBTypeConverted(converter = EntityTypeConverter.class)
    @DynamoDBIndexRangeKey(globalSecondaryIndexName = "accreditationState-entityType-index")
    private EntityTypeEnum entityType = null;

    //TODO Make this a list of notes; same for userNote
    @JsonProperty("adminNote")
    @DynamoDBAttribute
    private AccreditationNote adminNote = null;

    @JsonProperty("userNote")
    @DynamoDBAttribute
    private AccreditationNote userNote = null;


    /**
     * No arg constructor; sets the Date
     */
    public Accreditation() {
        this.date = Calendar.getInstance().getTime();
    }


    public void addDocumentsItem(Document documentsItem) {
        this.documents.add(documentsItem);
    }


    @JsonProperty("accreditationState")
    public AccreditationStateEnum getAccreditationState() {
        return accreditationState;
    }


    /**
     * All documents submitted by a applicant.
     *
     * @return documents
     **/
    @JsonProperty("documents")
    @Valid
    public List<Document> getDocuments() {
        return documents;
    }

    @Override
    public String toString() {
        return "{\"Accreditation\":{"
                + "\"accreditationId\":\"" + accreditationId + "\""
                + ",\"date\":\"" + date + "\""
                + ",\"entityId\":\"" + entityId + "\""
                + ",\"role\":\"" + role + "\""
                + ",\"documents\":" + documents
                + ",\"accreditationState\":\"" + accreditationState + "\""
                + ",\"adminNote\":" + adminNote
                + ",\"userNote\":" + userNote
                + "}}";
    }


    public enum RoleEnum {
        COMMUNITYADMIN("Community Admin"),
        SPONSORDONOR("Sponsor/Donor"),
        COMMUNITYMEMBER("Community Member"),
        SUPPLIER("Supplier"),
        EXPERT("Expert"),
        COMMUNITYLEADER("Community Leader"),
        RELIEFWORKER("Relief Worker"),
        HEALTHWORKER("Health Worker");

        private final String value;

        RoleEnum(String value) {
            this.value = value;
        }

        @JsonCreator
        public static RoleEnum fromValue(String text) {
            for (RoleEnum b : RoleEnum.values()) {
                if (String.valueOf(b.value).equals(text)) {
                    return b;
                }
            }
            return null;
        }

        @Override
        @JsonValue
        public String toString() {
            return String.valueOf(value);
        }
    }

    /**
     * Accreditation state. This value is set by an administrator after reviewing the application. All applications start with Pending state.
     */
    public enum AccreditationStateEnum {

        PENDING("Pending"),

        APPROVED("Approved"),

        MORE_INFO_NEEDED("More Info Needed"),

        REJECTED("Rejected"),

        DELETED("Deleted");

        private final String value;

        AccreditationStateEnum(String value) {
            this.value = value;
        }

        @JsonCreator
        public static AccreditationStateEnum fromValue(String text) {
            for (AccreditationStateEnum b : AccreditationStateEnum.values()) {
                if (String.valueOf(b.value).equals(text)) {
                    return b;
                }
            }
            return null;
        }

        @Override
        @JsonValue
        public String toString() {
            return String.valueOf(value);
        }
    }

    public enum EntityTypeEnum {
        ORG("ORG"),

        PER("PER");

        private final String value;

        EntityTypeEnum(String value) {
            this.value = value;
        }

        @JsonCreator
        public static EntityTypeEnum fromValue(String text) {
            for (EntityTypeEnum b : EntityTypeEnum.values()) {
                if (String.valueOf(b.value).equals(text)) {
                    return b;
                }
            }
            return null;
        }

        @Override
        @JsonValue
        public String toString() {
            return String.valueOf(value);
        }
    }


}

